/*!
  * Licensed Materials - Property of IBM
  * 5725N95, 5725P55, 5725N96
  * (C) Copyright IBM Corp. 1999, 2014.
  * US Government Users Restricted Rights- Use, duplication or disclosure
  * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

 /* $Id$ */
 
var assessment_buttons = ["Prev","Next","Glossary","Refresh","Menu","Prev","Next","Score"];
var buttonMap = {};
 
function init()
{
	var ye = YAHOO.util.Event;
	
	ye.addListener(assessment_buttons,"mouseover",buttonEffect);
	ye.addListener(assessment_buttons,"mouseout",buttonEffect);
	
	page(1);
}

function buttonEffect(e)
{
	var id = e.srcElement.id;

	if ((buttonMap[id] == null) || buttonMap[id])
	{
		var elm = YAHOO.util.Dom.get(id);

		if (e.type == "mouseover")
		{
			elm.src = window[id+"_on"].src;
			elm.alt = window[id+"_on"].alt;
		}
		else if (e.type == "mouseout")
		{
			elm.src = window[id+"_off"].src;
			elm.alt = window[id+"_off"].alt;
		}
	}
}

function updateButtons()
{
	var elm, state;
	for (var id in buttonMap)
	{
		state = (buttonMap[id]) ? "off" : "dis";
		elm = YAHOO.util.Dom.get(id);
		if(elm) {
			elm.src = window[id+"_"+state].src;
			elm.alt = window[id+"_"+state].alt;
		}
	}
}
 
function page(num)
{
	var yd = YAHOO.util.Dom;
	
	currentPage = num;

	updatePageNumber();

	for (var i=1;i<=pageCount;i++)
	{
		yd.setStyle("Page"+i,"visibility",((i==num)?"visible":"hidden"));
	}
	
	if (currentPage == pageCount)
	{
		yd.setStyle("scorediv","visibility","visible");
		yd.setStyle("prevquestiondiv","visibility","hidden");
		yd.setStyle("nextquestiondiv","visibility","hidden");
		
		buttonMap["Next"] = false;
	}
	else
	{
		yd.setStyle("scorediv","visibility","hidden");
		
		buttonMap["Next"] = true;
	}
	
	buttonMap["Prev"] = (currentPage > 1);
	
	updateButtons();
}

function previousPage()
{
	if ( currentPage > 1 )
	{
		page(currentPage-1);
	}
}

function nextPage()
{
	var ae = AssessmentEngine;
	if ( currentPage != pageCount )
	{
		if ((!ae.assessment.allowSkipQuestions && !ae.assessment.allowBackwardsNavigation) && !ae.isPageCompleted(currentPage))
		{
			// not allowed to navigate backwards and not allowed to skip and the page has unanswered questions
			alert(ae.skippedNotAllowedMsg);
		}
		else
		{
			page(currentPage+1);
		}
	}
}

function updatePageNumber()
{
	YAHOO.util.Dom.get("questionCnt").innerHTML = questionCountLabel+" "+currentPage+" "+questionCountMidLabel+" "+numQuestions;
}

function updateTimer()
{
	if (AssessmentEngine.remaining == timerWarning)
	{
		// show warning here
	}
	
	document.getElementById("timerdiv").innerHTML = 
		"<span class=\"ba-timertextstyle\">"+timerLabel+" "+formatDisplayTime(AssessmentEngine.remaining)+"</span>";
}
AssessmentEngine.events.timerUpdated.subscribe(updateTimer);

function disableScoreButton()
{
	document.forms["btnForm"]["Grade"].disabled = true;
}
AssessmentEngine.events.beforeScore.subscribe(disableScoreButton);

function expired() 
{ 
	AssessmentEngine.score();
}

function formatDisplayTime(r) 
{
	var h = 0;
	var m = 0;
	var s = 0;
	
	if ( r < 60 ) 
	{
		s = r;
	}
	else if ( r < 3600 ) 
	{
		m = Math.floor(r / 60);
		s = (r - (m * 60));
	}
	else {
		h = Math.floor( r / 3600 );
		m = Math.floor(( r - (h * 3600)) / 60 );
		s = (r - ( h * 3600 ) - ( m * 60 ));
	}
	
	if (m < 10) m = "0"+m;
	if (s < 10) s = "0"+s;
    
    return h+":"+m+":"+s;
}

YAHOO.util.Event.onDOMReady(init);